searchNodes=[{"ref":"Want.html","title":"Want","type":"module","doc":"Type conversion library for Elixir and Erlang."},{"ref":"Want.html#atom/1","title":"Want.atom/1","type":"function","doc":"Cast a value to an atom. Options :exists - If true, only convert to an atom if a matching atom already exists. :default - If conversion fails, this value should be returned instead. Examples iex&gt; Want.atom(&quot;hello&quot;) iex&gt; Want.atom(1.0) iex&gt; Want.atom({:a, :b}) {:error, &quot;Failed to convert value {:a, :b} to atom.&quot;} iex&gt; Want.atom({:a, :b}, default: :c) iex&gt; Want.atom(&quot;10&quot;, exists: true)"},{"ref":"Want.html#atom/2","title":"Want.atom/2","type":"function","doc":""},{"ref":"Want.html#atom!/1","title":"Want.atom!/1","type":"function","doc":""},{"ref":"Want.html#atom!/2","title":"Want.atom!/2","type":"function","doc":""},{"ref":"Want.html#dump/1","title":"Want.dump/1","type":"function","doc":"Dump a casted input into a more serializable form. Typically used to generate Phoenix query parameters. Options :update - Update the input value using Want.Update protocol before dumping Examples iex&gt; Want.dump({:inserted_at, :desc}) iex&gt; Want.dump({:inserted_at, :desc}, update: :inserted_at) iex&gt; Want.dump({:inserted_at, :desc}, update: :updated_at) iex&gt; Want.dump(&quot;hello&quot;) iex&gt; Want.dump(%{hello: :world, sort: {:inserted_at, :desc}}) iex&gt; Want.dump(%{hello: :world, sort: {:inserted_at, :desc}}, update: [sort: :inserted_at]) iex&gt; Want.dump({:a, :b, :c}) {:error, &quot;Unrecognized dump input {:a, :b, :c}&quot;}"},{"ref":"Want.html#dump/2","title":"Want.dump/2","type":"function","doc":""},{"ref":"Want.html#dump!/1","title":"Want.dump!/1","type":"function","doc":""},{"ref":"Want.html#dump!/2","title":"Want.dump!/2","type":"function","doc":""},{"ref":"Want.html#enum/2","title":"Want.enum/2","type":"function","doc":"Cast an input value to an enum. The input must loosely match one of the allowed values in order for the cast to succeed. Options :valid - List of valid enum values. The input must loosely match one of these. :default - If conversion fails, this value should be returned instead. Examples iex&gt; Want.enum(&quot;hello&quot;, valid: [:hello, :world]) iex&gt; Want.enum(&quot;hello&quot;, valid: [&quot;hello&quot;, :world]) iex&gt; Want.enum(&quot;foo&quot;, valid: [&quot;hello&quot;, :world], default: :bar)"},{"ref":"Want.html#enum!/2","title":"Want.enum!/2","type":"function","doc":""},{"ref":"Want.html#float/1","title":"Want.float/1","type":"function","doc":"Convert a value to a float. Options :max - Maximum allowable float value. :min - Minimum allowable float value. :default - If conversion fails, this value should be returned instead. Examples iex&gt; Want.float(1.0) iex&gt; Want.float({:a, :b}, default: 1.0) iex&gt; Want.float(:&#39;5.0&#39;, max: 3.0) iex&gt; Want.float(&quot;1.0&quot;, min: 3.0)"},{"ref":"Want.html#float/2","title":"Want.float/2","type":"function","doc":""},{"ref":"Want.html#float!/1","title":"Want.float!/1","type":"function","doc":""},{"ref":"Want.html#float!/2","title":"Want.float!/2","type":"function","doc":""},{"ref":"Want.html#integer/1","title":"Want.integer/1","type":"function","doc":"Convert a value to an integer. Options :max - Maximum allowable integer value. :min - Minimum allowable integer value. :default - If conversion fails, this value should be returned instead. Examples iex&gt; Want.integer(1.0) iex&gt; Want.integer({:a, :b}, default: 1) iex&gt; Want.integer(:&#39;5&#39;, max: 3) iex&gt; Want.integer(&quot;1&quot;, min: 3)"},{"ref":"Want.html#integer/2","title":"Want.integer/2","type":"function","doc":""},{"ref":"Want.html#integer!/1","title":"Want.integer!/1","type":"function","doc":""},{"ref":"Want.html#integer!/2","title":"Want.integer!/2","type":"function","doc":""},{"ref":"Want.html#map/2","title":"Want.map/2","type":"function","doc":"Cast an incoming keyword list or map to an output map using the provided schema to control conversion rules and validations. Each value in the schema map represents conversion options. Specify a :type field to cast the input value for a given key to that type, defaults to :string. Specific conversion and validation options for each type corresponds to those available for Want.integer/2, Want.float/2, Want.string/2 and Want.atom/2. Maps can be nested by using Examples iex&gt; Want.map(%{&quot;id&quot; =&gt; 1}, %{id: [type: :integer]}) {:ok, %{id: 1}} iex&gt; Want.map(%{}, %{id: [type: :integer, default: 1]}) {:ok, %{id: 1}} iex&gt; Want.map(%{&quot;id&quot; =&gt; &quot;bananas&quot;}, %{id: [type: :integer, default: 1]}) {:ok, %{id: 1}} iex&gt; Want.map(%{&quot;hello&quot; =&gt; &quot;world&quot;, &quot;foo&quot; =&gt; &quot;bar&quot;}, %{hello: [], foo: [type: :atom]}) {:ok, %{hello: &quot;world&quot;, foo: :bar}} iex&gt; Want.map(%{&quot;hello&quot; =&gt; %{&quot;foo&quot; =&gt; &quot;bar&quot;}}, %{hello: %{foo: [type: :atom]}}) {:ok, %{hello: %{foo: :bar}}}"},{"ref":"Want.html#map!/2","title":"Want.map!/2","type":"function","doc":""},{"ref":"Want.html#sort/2","title":"Want.sort/2","type":"function","doc":"Cast an input to a sort tuple. Options :fields - List of allowed sort fields. Casting will fail if the input doesn&#39;t match any of these. :default - If conversion fails, this value should be returned instead. Examples iex&gt; Want.sort(&quot;inserted_at:desc&quot;, fields: [:inserted_at, :id, :name]) {:ok, {:inserted_at, :desc}} iex&gt; Want.sort(&quot;updated_at&quot;, fields: [:inserted_at, :id], default: {:id, :asc}) {:ok, {:id, :asc}} iex&gt; Want.sort(&quot;updated_at:asc&quot;, [])"},{"ref":"Want.html#sort!/2","title":"Want.sort!/2","type":"function","doc":""},{"ref":"Want.html#string/1","title":"Want.string/1","type":"function","doc":"Convert a value to a string. Options :max - Maximum allowable string length. :min - Minimum allowable string length. :matches - The resulting string must match the given regex. :default - If conversion fails, this value should be returned instead. Examples iex&gt; Want.string(1) iex&gt; Want.string({:a, :b}, default: &quot;string&quot;) iex&gt; Want.string(:hello, max: 3) iex&gt; Want.string(:a, min: 3) iex&gt; Want.string(:a, matches: ~r/a/)"},{"ref":"Want.html#string/2","title":"Want.string/2","type":"function","doc":""},{"ref":"Want.html#string!/1","title":"Want.string!/1","type":"function","doc":""},{"ref":"Want.html#string!/2","title":"Want.string!/2","type":"function","doc":""},{"ref":"Want.Any.html","title":"Want.Any","type":"module","doc":""},{"ref":"Want.Atom.html","title":"Want.Atom","type":"module","doc":"Performs type conversions to atom values."},{"ref":"Want.Atom.html#cast/1","title":"Want.Atom.cast/1","type":"function","doc":"Cast a value to an atom. Options :exists - If true, only convert to an atom if a matching atom already exists. Examples iex&gt; Want.Atom.cast(&quot;hello&quot;) iex&gt; Want.Atom.cast(1.0) iex&gt; Want.Atom.cast({:a, :b}) {:error, &quot;Failed to convert value {:a, :b} to atom.&quot;} iex&gt; Want.Atom.cast(&quot;10&quot;, exists: true)"},{"ref":"Want.Atom.html#cast/2","title":"Want.Atom.cast/2","type":"function","doc":"Callback implementation for Want.Type.cast/2."},{"ref":"Want.Atom.html#t:result/0","title":"Want.Atom.result/0","type":"type","doc":""},{"ref":"Want.Dump.html","title":"Want.Dump","type":"protocol","doc":"Behaviour for type casting modules."},{"ref":"Want.Dump.html#dump/2","title":"Want.Dump.dump/2","type":"function","doc":"Dumps an incoming value to an output type."},{"ref":"Want.Dump.html#t:t/0","title":"Want.Dump.t/0","type":"type","doc":""},{"ref":"Want.Enum.html","title":"Want.Enum","type":"module","doc":"Provides type conversions to enumerations."},{"ref":"Want.Enum.html#cast/2","title":"Want.Enum.cast/2","type":"function","doc":"Cast a given value to an enum value. The given options keyword list must include an array of valid enum values under the :valid key, otherwise the function will return an error tuple. Options :valid - List of valid enum values. The input must loosely match one of these. Examples iex&gt; Want.Enum.cast(&quot;hello&quot;, valid: [:hello, :world]) iex&gt; Want.Enum.cast(&quot;hello&quot;, valid: [&quot;hello&quot;, :world])"},{"ref":"Want.Enum.html#cast/3","title":"Want.Enum.cast/3","type":"function","doc":""},{"ref":"Want.Enum.html#t:result/0","title":"Want.Enum.result/0","type":"type","doc":""},{"ref":"Want.Float.html","title":"Want.Float","type":"module","doc":"Performs type conversions to float values."},{"ref":"Want.Float.html#cast/1","title":"Want.Float.cast/1","type":"function","doc":"Cast a value to a float. Options :max - Maximum allowable float value. :min - Minimum allowable float value. Examples iex&gt; Want.Float.cast(&quot;1&quot;) iex&gt; Want.Float.cast(1.0) iex&gt; Want.Float.cast(:&#39;1&#39;) iex&gt; Want.Float.cast({:a, :b}) {:error, &quot;Failed to convert value {:a, :b} to float.&quot;} iex&gt; Want.Float.cast(&quot;10&quot;, max: 3.0) iex&gt; Want.Float.cast(1.0, min: 3.0)"},{"ref":"Want.Float.html#cast/2","title":"Want.Float.cast/2","type":"function","doc":"Callback implementation for Want.Type.cast/2."},{"ref":"Want.Float.html#t:result/0","title":"Want.Float.result/0","type":"type","doc":""},{"ref":"Want.Integer.html","title":"Want.Integer","type":"module","doc":"Manages conversions to and from integers."},{"ref":"Want.Integer.html#cast/1","title":"Want.Integer.cast/1","type":"function","doc":"Cast a value to an integer. Options :max - Maximum allowable integer value. :min - Minimum allowable integer value. Examples iex&gt; Want.Integer.cast(&quot;1&quot;) iex&gt; Want.Integer.cast(1.0) iex&gt; Want.Integer.cast(:&#39;1&#39;) iex&gt; Want.Integer.cast({:a, :b}) {:error, &quot;Failed to convert value {:a, :b} to integer.&quot;} iex&gt; Want.Integer.cast(&quot;10&quot;, max: 3) iex&gt; Want.Integer.cast(1.0, min: 3)"},{"ref":"Want.Integer.html#cast/2","title":"Want.Integer.cast/2","type":"function","doc":"Callback implementation for Want.Type.cast/2."},{"ref":"Want.Integer.html#t:result/0","title":"Want.Integer.result/0","type":"type","doc":""},{"ref":"Want.Map.html","title":"Want.Map","type":"module","doc":"Manages conversions to and from maps."},{"ref":"Want.Map.html#cast/2","title":"Want.Map.cast/2","type":"function","doc":"Cast an incoming keyword list or map to an output map using the provided schema to control conversion rules and validations. Examples iex&gt; Want.Map.cast(%{&quot;id&quot; =&gt; 1}, %{id: [type: :integer]}) {:ok, %{id: 1}} iex&gt; Want.Map.cast(%{}, %{id: [type: :integer, default: 1]}) {:ok, %{id: 1}} iex&gt; Want.Map.cast(%{&quot;id&quot; =&gt; &quot;bananas&quot;}, %{id: [type: :integer, default: 1]}) {:ok, %{id: 1}} iex&gt; Want.Map.cast(%{&quot;hello&quot; =&gt; &quot;world&quot;, &quot;foo&quot; =&gt; &quot;bar&quot;}, %{hello: [], foo: [type: :atom]}) {:ok, %{hello: &quot;world&quot;, foo: :bar}} iex&gt; Want.Map.cast(%{&quot;hello&quot; =&gt; %{&quot;foo&quot; =&gt; &quot;bar&quot;}}, %{hello: %{foo: [type: :atom]}}) {:ok, %{hello: %{foo: :bar}}}"},{"ref":"Want.Map.html#cast/3","title":"Want.Map.cast/3","type":"function","doc":""},{"ref":"Want.Map.html#t:input/0","title":"Want.Map.input/0","type":"type","doc":""},{"ref":"Want.Map.html#t:key/0","title":"Want.Map.key/0","type":"type","doc":""},{"ref":"Want.Map.html#t:opts/0","title":"Want.Map.opts/0","type":"type","doc":""},{"ref":"Want.Map.html#t:result/0","title":"Want.Map.result/0","type":"type","doc":""},{"ref":"Want.Map.html#t:schema/0","title":"Want.Map.schema/0","type":"type","doc":""},{"ref":"Want.Sort.html","title":"Want.Sort","type":"module","doc":"Specialized functions for dealing with sort parameters in Phoenix requests."},{"ref":"Want.Sort.html#cast/2","title":"Want.Sort.cast/2","type":"function","doc":"Callback implementation for Want.Type.cast/2."},{"ref":"Want.Sort.html#cast/3","title":"Want.Sort.cast/3","type":"function","doc":""},{"ref":"Want.Sort.html#t:direction/0","title":"Want.Sort.direction/0","type":"type","doc":""},{"ref":"Want.Sort.html#t:result/0","title":"Want.Sort.result/0","type":"type","doc":""},{"ref":"Want.Sort.html#t:sort/0","title":"Want.Sort.sort/0","type":"type","doc":""},{"ref":"Want.String.html","title":"Want.String","type":"module","doc":"Manages conversions to and from strings."},{"ref":"Want.String.html#cast/1","title":"Want.String.cast/1","type":"function","doc":"Casts a given value to a string. Options :max - Maximum allowable string length. :min - Minimum allowable string length. :matches - The resulting string must match the given regex. Examples iex&gt; Want.String.cast(1) iex&gt; Want.String.cast({:a, :b}) {:error, &quot;Failed to convert value {:a, :b} to string.&quot;} iex&gt; Want.String.cast(:hello, max: 3) iex&gt; Want.String.cast(:a, min: 3) iex&gt; Want.String.cast(:a, matches: ~r/a/)"},{"ref":"Want.String.html#cast/2","title":"Want.String.cast/2","type":"function","doc":"Callback implementation for Want.Type.cast/2."},{"ref":"Want.String.html#t:result/0","title":"Want.String.result/0","type":"type","doc":""},{"ref":"Want.Type.html","title":"Want.Type","type":"behaviour","doc":"Behaviour for type casting modules."},{"ref":"Want.Type.html#c:cast/2","title":"Want.Type.cast/2","type":"callback","doc":""},{"ref":"Want.Update.html","title":"Want.Update","type":"protocol","doc":"Behaviour for type casting modules."},{"ref":"Want.Update.html#update/2","title":"Want.Update.update/2","type":"function","doc":"Updates an existing value with a new one"},{"ref":"Want.Update.html#t:t/0","title":"Want.Update.t/0","type":"type","doc":""}]